do
    local oldModBlueprints = ModBlueprints

    function ModBlueprints(all_bps)
        oldModBlueprints(all_bps)

        local g = 4.9 # this is the game-unit gravity. prolly comes about from 1/2.a^2

        for id,bp in all_bps.Unit do

            if bp.Weapon then 

                for ik, wep in bp.Weapon do

                  # filter out beam weapons.
                    if wep.MuzzleVelocity then

                      # the maths says there's a factor of sqrt(2). 
                      # we need gravity here too.

                        wep.ProjectileLifetime = math.sqrt(2.0) * wep.MuzzleVelocity / g

                      # the following takes into consideration of angles inherently,
                      # as the ProjectileLifetime is longest the projectile can possibly stay in the air for.
                      # there is really no need for extra range due to height advantages.
                        wep.MaxRadius = wep.MuzzleVelocity * wep.ProjectileLifetime

                    end

                end # bp.Weapon loop.

            end 

        end # all_bps.Unit loop.

    end

end